/**
  *  ==============================================================
  *  ArrayTest1.java: This java class explorss the use of arraylist
  *  and iterators to build arrays of nodes, edges, and triangles.
  * 
  * 
  *  Written by: Mark Austin                         November, 2004 
  *  ==============================================================
  */

package arraylist01;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class ArrayTest1 {

   public static void main( String args[] ) {

      // Create and print a simple array of strings .....

      List stringList = new ArrayList();

      stringList.add("node 1");
      stringList.add("node 2");
      stringList.add("node 3");
      stringList.add("node 4");
      stringList.add("node 5");

      System.out.println("Walk along list and print strings" );
      System.out.println("=================================" );

      Iterator iterator1 = stringList.iterator();
      while ( iterator1.hasNext() != false ) {
          String s = (String) iterator1.next();
          System.out.println("Name = " + s );
      }

      // Create simple array of polygon nodes .....

      Node n1 = new Node ("p1", 0.0, 0.0);
      Node n2 = new Node ("p2", 5.0, 0.0);
      Node n3 = new Node ("p3", 5.0, 5.0);
      Node n4 = new Node ("p4", 2.5, 7.0);
      Node n5 = new Node ("p5", 0.0, 5.0);
      Node n6 = new Node ("p6", 0.0, 0.0);

      List nodeList = new ArrayList();
      nodeList.add( n1 );
      nodeList.add( n2 );
      nodeList.add( n3 );
      nodeList.add( n4 );
      nodeList.add( n5 );
      nodeList.add( n6 );

      // Print details of polygon nodes .....

      System.out.println("");
      System.out.println("Polygon node list");
      System.out.println("====================================");

      Iterator iterator2 = nodeList.iterator();
      while ( iterator2.hasNext() != false ) {
          Node n = (Node) iterator2.next();
          System.out.println( n.toString() );
      }

      System.out.println("====================================");

      // Create simple array of polygon edges .....

      List edgeList = new ArrayList();

      Edge eA = new Edge ("e1", n1, n2);
      Edge eB = new Edge ("e2", n2, n3);
      Edge eC = new Edge ("e3", n3, n4);
      Edge eD = new Edge ("e4", n4, n5);
      Edge eE = new Edge ("e5", n5, n6);
      Edge eF = new Edge ("e6", n6, n1);

      edgeList.add( eA );
      edgeList.add( eB );
      edgeList.add( eC );
      edgeList.add( eD );
      edgeList.add( eE );
      edgeList.add( eF );

      // Print details of polygon edges .....

      System.out.println("");
      System.out.println("Polygon edge list");
      System.out.println("====================================");

      Iterator iterator3 = edgeList.iterator();
      while ( iterator3.hasNext() != false ) {
          Edge e = (Edge) iterator3.next();
          System.out.println( e.toString() );
      }

      System.out.println("====================================");

      // Compute and print perimeter of polygon .....

      double dPerimeter = 0.0;
      Iterator iterator4 = edgeList.iterator();
      while ( iterator4.hasNext() != false ) {
          Edge e = (Edge) iterator4.next();
          dPerimeter += e.length();
      }

      System.out.println("Polygon perimeter = " + dPerimeter );
      System.out.println("====================================");

   }
}
