/*
 * ============================================================================
 * DemoGraduateFilterAndSort.java: Exercise filter and sort capabilities ...
 * ============================================================================
 */

package filter02;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;

public class DemoGraduateFilterAndSort {
   public static void main(String[] args) {

      System.out.printf("DemoGraduateFilterAndSort ...\n");
      System.out.printf("====================================== ...\n");

      // Assemble student objects ...

      System.out.printf("--- Assemble student objects ...\n");

      Student mark = new Student("Mark", "UMCP");
      mark.setAge( 22 );

      Student maria = new Student("Maria", "UMCP");
      maria.setAge( 27 );

      Student nina = new Student("Nina", "JHU");
      nina.setAge( 22 );

      Student lisa = new Student("Lisa", "UCLA");
      lisa.setAge( 20 );

      Student david = new Student("David", "UT Austin");
      david.setAge( 30 );

      System.out.println(  mark.toString() );
      System.out.println( maria.toString() );
      System.out.println(  nina.toString() );
      System.out.println(  lisa.toString() );
      System.out.println( david.toString() );

      // Assemble and print arraylist of graduate objects ...

      System.out.printf("--- \n");
      System.out.printf("--- Assemble arraylist of graduates ...\n");

      List<Graduate> gr = new ArrayList<Graduate>();
      gr.add ( new Graduate(  mark, 2011, 2.5) );
      gr.add ( new Graduate( maria, 2012, 3.9) );
      gr.add ( new Graduate( maria, 2014, 3.7) );
      gr.add ( new Graduate( maria, 2017, 3.7) );
      gr.add ( new Graduate(  nina, 2011, 4.0) );
      gr.add ( new Graduate(  nina, 2012, 3.5) );
      gr.add ( new Graduate(  lisa, 2011, 3.2) );
      gr.add ( new Graduate(  lisa, 2012, 4.0) );
      gr.add ( new Graduate(  lisa, 2016, 3.7) );
      gr.add ( new Graduate( david, 2011, 3.1) );
      gr.add ( new Graduate( david, 2018, 3.8) );

      for ( int i = 0; i < gr.size(); i = i + 1 ) {
          Graduate item = gr.get(i);
          System.out.println( item.toString() );
      }

      System.out.printf("--- \n");
      System.out.printf("--- Filter 2011 graduate list, then sort by GPA ...\n");
    
      List<Graduate> gr2011 = gr.stream()
                                .filter(t -> t.getYear() == 2011)
                                .sorted(Comparator.comparing(Graduate::getGPA) )
                                .collect(Collectors.toList());

      for ( int i = 0; i < gr2011.size(); i = i + 1 ) {
          Graduate item = gr2011.get(i);
          System.out.println( item.toString() );
      }

      System.out.printf("--- \n");
      System.out.printf("--- Filter 2012 graduate list, then sort by GPA ...\n");
    
      List<Graduate> gr2012 = gr.stream()
                                .filter(t -> t.getYear() == 2012)
                                .sorted(Comparator.comparing(Graduate::getGPA) )
                                .collect(Collectors.toList());

      // Print filtered and sorted list of graduates ... 

      for ( int i = 0; i < gr2012.size(); i = i + 1 ) {
          Graduate item = gr2012.get(i);
          System.out.println( item.toString() );
      }

      System.out.printf("====================================== ...\n");
      System.out.printf("Finished ...\n");
   }
}
