/*
 *  =========================================================================
 *  DemoFilterWithMap01.java: Use filter and map to generate a list ...
 *  =========================================================================
 */
package filter03;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
 
public class DemoFilterWithMap01 {
    public static void main(String[] args) {

        System.out.printf("Enter DemoFilterWithMap01.main() ...\n");
        System.out.printf("====================================== ...\n");

        System.out.printf("--- Assemble list of integers ...\n");

        List<Integer> list = Arrays.asList(1, 2, 3, 4, 5, 6, 7, 8, 9, 10);

        System.out.printf("--- List: %s ...\n", list.toString());

        System.out.printf("--- Filter even numbers, then map to square of value ...\n");
 
        List<Integer> evenNumbers = list.stream()
                    .filter(n -> n % 2 == 0)
                    .map(n -> n * n)
                    .collect(Collectors.toList());

        System.out.printf("--- Print list of even numbers squared ...\n");
         
        System.out.printf("--- List: %s ...\n", evenNumbers.toString());

        System.out.println("====================================== ...\n");
        System.out.println("Finished !! ...\n");
    }
}
