/*
 *  =========================================================================
 *  DemoFilterWithPredicate01.java: Use predicate to filter a list ...
 *  =========================================================================
 */
package filter03;

import java.util.Arrays;
import java.util.List;
import java.util.function.Predicate;
 
public class DemoFilterWithPredicate01 {
    public static void main(String[] args) {

        System.out.printf("Enter DemoFilterWithPredicate01.main() ...\n");
        System.out.printf("====================================== ...\n");

        System.out.printf("--- Assemble list of integers ...\n");

        List<Integer> list = Arrays.asList(1, 2, 3, 4, 5, 6, 7, 8, 9, 10);

        System.out.printf("--- List: %s ...\n", list.toString());

        System.out.printf("--- Define predicate (keep even numbers) ...\n");
         
        Predicate<Integer> condition = new Predicate<Integer>() {
            @Override
            public boolean test(Integer n) {
                if (n % 2 == 0) {
                    return true;
                }
                return false;
            }
        };

        System.out.printf("--- Compute and print filtered list of even numbers ...\n");
 
        list.stream().filter(condition).forEach(System.out::println);

        System.out.println("====================================== ...\n");
        System.out.println("Finished !! ...\n");
    }
}
