/**
 *  =======================================================================
 *  WeatherDataItem.java: Weather measurements ...
 *  =======================================================================
 */

package filter04;

import java.util.Date;
import java.time.LocalDate;

public class WeatherDataItem {
   boolean DEBUG = false;
   private String date;
   private int day;
   private int month;
   private int year;
   private float precipitation;
   private float minTemp;
   private float maxTemp;

   public WeatherDataItem () {}

   // ====================================================
   // Set/get weather measurement attributes ...
   // ====================================================

   public void setDate ( String date ) {
      this.date = date;

      // Create date object from string input ...

      LocalDate dateItem = LocalDate.parse( date );
      this.day   = dateItem.getDayOfMonth();
      this.month = dateItem.getMonthValue();
      this.year  = dateItem.getYear();
   }

   // Set precipitation ...

   public void setPrecipitation ( float precipitation ) {
      this.precipitation = precipitation;
   }

   // Set max and min temperatures ...

   public void setMaxTemp ( float maxTemp ) {
      this.maxTemp = maxTemp;
   }

   public void setMinTemp ( float minTemp ) {
      this.minTemp = minTemp;
   }

   // Retrieve day, month, year ...

   public int getDay() {
      return this.day;
   }

   public int getMonth() {
      return this.month;
   }

   public int getYear() {
      return this.year;
   }

   // ====================================================
   // Create string representation of weather data item ...
   // ====================================================

   public String toString() {
      StringBuffer buf = new StringBuffer();

      buf.append( String.format("Date: %s ... \n", date ));
      buf.append( String.format("Precipitation: %4.2f in ... \n", precipitation ));
      buf.append( String.format("Temperature Range: [ %4.1f, %4.1f ] ... \n", minTemp, maxTemp ));

      return buf.toString();
   }
}
