/* 
 *  ==========================================================================
 *  TestWeatherDataModel.java: Demo program to exercise weather data model on
 *                             weather conditions in Seattle.
 * 
 *  Written by: Mark Austin                                         April 2022 
 *  ==========================================================================
 */ 

package homework03;

import java.io.IOException;

public class TestWeatherDataModel {
    public static void main (String [] args ) {
       System.out.printf("Enter TestWeatherDataModel.main() ... \n");
       System.out.printf("================================= ... \n");

       // Create Weather data model ...

       WeatherDataModel weather = new WeatherDataModel();

       // Load data/seattle-weather.csv into model ...

       try {
          weather.loadDataFile("data/seattle-weather.csv");
       } catch (IOException e) {
          System.out.printf("Error: data file not found ...\n");
       }

       // Print summary of data ...

       System.out.println ( weather.toString() );

       // Export data to Weka (arff) file format 

       try {
          weather.exportARFF("./seattle-weather-data.arff");
       } catch (Exception e) {
          System.out.printf("Error: Export to ARFF file format failed ...\n");
       }

       System.out.printf("================================= ... \n");
       System.out.printf("Finished! ... \n");
    }
}
