/**
 * =======================================================================
 * SymbolTable.java: Framework interface that represents the symbol table.
 *
 * Copyright (c) 2009 by Ronald Mak
 * For instructional purposes only.  No warranties.
 * =======================================================================
 */

package symbol02;

import java.util.ArrayList;

public interface SymbolTable {

    // Get nesting level ...

    public int getNestingLevel();

    /**
     * Create and enter a new entry into the symbol table.
     * @param name the name of the entry.
     * @return the new entry.
     */

    public SymbolTableEntry enter(String name);

    /**
     * Look up an existing symbol table entry.
     * @param name the name of the entry.
     * @return the entry, or null if it does not exist.
     */
    public SymbolTableEntry lookup(String name);

    /**
     * @return a list of symbol table entries sorted by name.
     */
    public ArrayList<SymbolTableEntry> sortedEntries();
}
